From c6f5d77bba3f76438a43ed1a19cf27266de962c7 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Sep 11 2020 17:57:03 +0000
Subject: [PATCH 873/2232] Merge pull request #295 from dtolnay/detect


Detect when symlink not enabled
---

diff --git a/gen/build/Cargo.toml b/gen/build/Cargo.toml
index ce9b206..0eb9874 100644
--- a/gen/build/Cargo.toml
+++ b/gen/build/Cargo.toml
@@ -6,6 +6,7 @@ edition = "2018"
 license = "MIT OR Apache-2.0"
 description = "C++ code generator for integrating `cxx` crate into a Cargo build."
 repository = "https://github.com/dtolnay/cxx"
+exclude = ["build.rs"]
 keywords = ["ffi"]
 categories = ["development-tools::ffi"]
 
diff --git a/gen/build/build.rs b/gen/build/build.rs
new file mode 100644
index 0000000..b8ff9dd
--- /dev/null
+++ b/gen/build/build.rs
@@ -0,0 +1,29 @@
+use std::io::{self, Write};
+use std::path::Path;
+use std::process;
+
+const NOSYMLINK: &str = "
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+When building `cxx` from a git clone, git's symlink support needs
+to be enabled on platforms that have it off by default (Windows).
+Either use:
+
+   $ git config --global core.symlinks true
+
+prior to cloning, or else use:
+
+   $ git clone -c core.symlinks=true ...
+
+for the clone.
+
+Symlinks are only required for local development, not for building
+`cxx` as a (possibly transitive) dependency from crates.io.
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+";
+
+fn main() {
+    if !Path::new("src/syntax/mod.rs").exists() {
+        let _ = io::stderr().lock().write_all(NOSYMLINK.as_bytes());
+        process::exit(1);
+    }
+}
diff --git a/gen/cmd/Cargo.toml b/gen/cmd/Cargo.toml
index 376c9cd..2c548e6 100644
--- a/gen/cmd/Cargo.toml
+++ b/gen/cmd/Cargo.toml
@@ -6,6 +6,7 @@ edition = "2018"
 license = "MIT OR Apache-2.0"
 description = "C++ code generator for integrating `cxx` crate into a non-Cargo build."
 repository = "https://github.com/dtolnay/cxx"
+exclude = ["build.rs"]
 keywords = ["ffi"]
 categories = ["development-tools::ffi"]
 
diff --git a/gen/cmd/build.rs b/gen/cmd/build.rs
new file mode 100644
index 0000000..b8ff9dd
--- /dev/null
+++ b/gen/cmd/build.rs
@@ -0,0 +1,29 @@
+use std::io::{self, Write};
+use std::path::Path;
+use std::process;
+
+const NOSYMLINK: &str = "
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+When building `cxx` from a git clone, git's symlink support needs
+to be enabled on platforms that have it off by default (Windows).
+Either use:
+
+   $ git config --global core.symlinks true
+
+prior to cloning, or else use:
+
+   $ git clone -c core.symlinks=true ...
+
+for the clone.
+
+Symlinks are only required for local development, not for building
+`cxx` as a (possibly transitive) dependency from crates.io.
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+";
+
+fn main() {
+    if !Path::new("src/syntax/mod.rs").exists() {
+        let _ = io::stderr().lock().write_all(NOSYMLINK.as_bytes());
+        process::exit(1);
+    }
+}
diff --git a/gen/lib/Cargo.toml b/gen/lib/Cargo.toml
index 48a4b72..db6de83 100644
--- a/gen/lib/Cargo.toml
+++ b/gen/lib/Cargo.toml
@@ -6,6 +6,7 @@ edition = "2018"
 license = "MIT OR Apache-2.0"
 description = "C++ code generator for integrating `cxx` crate into higher level tools."
 repository = "https://github.com/dtolnay/cxx"
+exclude = ["build.rs"]
 keywords = ["ffi"]
 categories = ["development-tools::ffi"]
 
diff --git a/gen/lib/build.rs b/gen/lib/build.rs
new file mode 100644
index 0000000..b8ff9dd
--- /dev/null
+++ b/gen/lib/build.rs
@@ -0,0 +1,29 @@
+use std::io::{self, Write};
+use std::path::Path;
+use std::process;
+
+const NOSYMLINK: &str = "
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+When building `cxx` from a git clone, git's symlink support needs
+to be enabled on platforms that have it off by default (Windows).
+Either use:
+
+   $ git config --global core.symlinks true
+
+prior to cloning, or else use:
+
+   $ git clone -c core.symlinks=true ...
+
+for the clone.
+
+Symlinks are only required for local development, not for building
+`cxx` as a (possibly transitive) dependency from crates.io.
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+";
+
+fn main() {
+    if !Path::new("src/syntax/mod.rs").exists() {
+        let _ = io::stderr().lock().write_all(NOSYMLINK.as_bytes());
+        process::exit(1);
+    }
+}
diff --git a/macro/Cargo.toml b/macro/Cargo.toml
index e5a52e4..301a750 100644
--- a/macro/Cargo.toml
+++ b/macro/Cargo.toml
@@ -6,7 +6,7 @@ edition = "2018"
 license = "MIT OR Apache-2.0"
 description = "Implementation detail of the `cxx` crate."
 repository = "https://github.com/dtolnay/cxx"
-exclude = ["README.md"]
+exclude = ["build.rs", "README.md"]
 keywords = ["ffi"]
 categories = ["development-tools::ffi"]
 
diff --git a/macro/build.rs b/macro/build.rs
new file mode 100644
index 0000000..b8ff9dd
--- /dev/null
+++ b/macro/build.rs
@@ -0,0 +1,29 @@
+use std::io::{self, Write};
+use std::path::Path;
+use std::process;
+
+const NOSYMLINK: &str = "
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+When building `cxx` from a git clone, git's symlink support needs
+to be enabled on platforms that have it off by default (Windows).
+Either use:
+
+   $ git config --global core.symlinks true
+
+prior to cloning, or else use:
+
+   $ git clone -c core.symlinks=true ...
+
+for the clone.
+
+Symlinks are only required for local development, not for building
+`cxx` as a (possibly transitive) dependency from crates.io.
+~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
+";
+
+fn main() {
+    if !Path::new("src/syntax/mod.rs").exists() {
+        let _ = io::stderr().lock().write_all(NOSYMLINK.as_bytes());
+        process::exit(1);
+    }
+}

